KDE 4.3 PyKDE API Reference

- KDE's Python API

# NRLModel Class Reference

`from PyKDE4.soprano import *`

Inherits: Soprano.FilterModel → Soprano.Model → QObject
Namespace: Soprano

## Detailed Description

\class NRLModel nrlmodel.h Soprano/NRLModel

Model filter that enforces NRL cardinality rules.

The NRLModel enforces NRL cardinality rules. That means predicates with a cardinality of maximum 1 are always udpated while statements that define predicates with a maximum cardinality bigger than 1 are rejected once the maximum is reached (future versions might remove an earlier defined statement based on the time the old statements were added).

Thus, at the moment NRLModel is mostly usable for handling properties with a maximum cardinality of 1.

THE API AND EVEN THE COMPLETE CLASS IS SUBJECT TO CHANGE!

Author:
  Sebastian Trueg <trueg@kde.org>

\sa Vocabulary.NRL

## Methods

| __init__ (self)
| __init__ (self, Soprano.Model parent)
Soprano.Error.ErrorCode | addNrlStatement (self, Soprano.Statement s)
QUrl | createGraph (self, QUrl type, QUrl metadataGraph=0)
bool | ignoreContext (self)
Soprano.Error.ErrorCode | removeGraph (self, QUrl graph)
| setIgnoreContext (self, bool b)

## Method Documentation

__init__ | ( |  | self ) |

__init__ | ( | self, |
|  | Soprano.Model | parent
| ) |  |  |

Soprano.Error.ErrorCode addNrlStatement | ( | self, |
|  | Soprano.Statement | s
| ) |  |  |

Add a statement.

Parameters:

  | s | The statement containing the property to be set. If the predicate has NRL cardinality restrictions existing statements will be updated. Otherwise this method has the same effect as Model.addStatement().

Adding a statement that defines a predicate with a maximum cardinality bigger than 1 which has already been reached fails with an error.

Returns:
  Error.ErrorNone on success.

QUrl createGraph | ( | self, |
|  | QUrl | type,
|  | QUrl | metadataGraph=0
| ) |  |  |

Create a new graph of type type.

This will actually create two graphs: the requested one and its metadata graph which will already contain basic metadata like creation date.

Returns:
  The URI of the newly created graph.

Since:
  2.3

bool ignoreContext | ( |  | self ) |

Returns:
  true if contexts should be ignored when enforcing NRL rules.

\sa setIgnoreContext()

Soprano.Error.ErrorCode removeGraph | ( | self, |
|  | QUrl | graph
| ) |  |  |

Remove a complete graph including its metadata graph

This method can be seen as the counterpart to createGraph

Since:
  2.3

setIgnoreContext | ( | self, |
|  | bool | b
| ) |  |  |

When enforcing the NRL cardinality rules NRLModel can either ignore the context of statements or treat different contexts as separate sets, each resetting the cardinality.

Parameters:

  | b | If true (the default) NRLModel does ignore the context when enforcing rules. If false the NRL rules can be violated across contexts.

\sa ignoreContext()